#include "xfsp.h"
#include <sys/param.h>
#include <pwd.h>
#include <strings.h>
#include <stdio.h>
#include "config.h"

extern Display *dpy;
extern char hostname[40], portname[6], lfilname[30], rdirname[70];
extern char rfilname[30], currdir[70], tempname[L_tmpnam];
static char fsp_host[80], fsp_port[64], fsp_dir[200];
extern XFontStruct *font;
extern GC gc;
extern int dirlen, dirs[256], entries, topent, numhosts, tophost;
extern char dates[256][20], names[256][30], sizes[256][10];
extern char home[60], hostf[40];

char tempfile[MAXPATHLEN+10];
char Lhosts[50][40], Lports[50][6], Lcomments[50][30];

runend()
{
  XUnloadFont(dpy, font->fid);
  XFreeGC(dpy, gc);
  XCloseDisplay(dpy);
  exit(0);
}

int execute(s)
char *s;
{
  int status,pid,w;
  register int (*istat)(), (*qstat)();

#ifdef VFORK
   pid = vfork();
#else
   pid = fork();
#endif

  if (pid == 0) {
   signal(SIGINT, SIG_DFL);
   signal(SIGQUIT, SIG_DFL);
   signal(SIGHUP, SIG_DFL);
   execl("/bin/sh", "sh", "-c", s, 0);
   _exit(127);
  }
 istat = signal(SIGINT, SIG_IGN);
 qstat = signal(SIGQUIT, SIG_IGN);
 while ((w = wait(&status)) != pid && w != -1) ;
 if (w == -1) status = -1;
 signal(SIGINT, istat);
 signal(SIGQUIT, qstat);
 return(status);
}

flist()
{
FILE *lfile;
char line[30];
int i = -2;

 entries = 0;
 topent = 0;
 strcpy(tempfile,tempname);
 lfile = fopen(tempfile, "r");
 while ((fscanf(lfile, "%s", line) != EOF)) {
 i++;
 if (i == 1) dirs[entries] = (line[0] == 100);
 if (i == 4) strcpy(sizes[entries],line);
 if (i == 5) strcpy(dates[entries],line);
 if (i == 6 || i == 7){
  strcat(dates[entries]," ");
  strcat(dates[entries],line);
 }
 if (i == 8) {
  strcpy(names[entries],line);
  i = 0;
  entries++;
  }
 }
 fclose(lfile);
 showentries();
}

selfile(by)
int by;
{
 int i , s;
 char tempstr[60];

 i = (((by - 30) / 15) + topent);
 if (i <= entries) {
 if (dirs[i]) {
  strcpy(rdirname, currdir);
  if (strcmp(names[i],"..") != 0) {
   strcpy(tempstr, "");
   strncat(tempstr, rdirname, dirlen);
   if (dirlen != 1) strcat(tempstr,"/");
   strcat(tempstr, names[i]);
   strcpy(rdirname, tempstr);
   }
  else
  {
   s = 1;
   i = 1;
    while (i < dirlen) {
     if (rdirname[i] == 47) s = i;
     i++;
     }
    strcpy(tempstr,"");
    strncat(tempstr,rdirname,s);
    strcpy(rdirname,tempstr);
   }
  } 
 else
 {
  strcpy(rfilname,names[i]);
  strcpy(tempstr, "");
  strncat(tempstr, rdirname, dirlen);
  strcpy(rdirname, tempstr);
 }
 showstrings();
 }
}

make_env()
{
 strcpy(fsp_host,"FSP_HOST=");
 strcat(fsp_host, hostname);
 (void) putenv(fsp_host);
 strcpy(fsp_port,"FSP_PORT=");
 strcat(fsp_port, portname);
 (void) putenv(fsp_port);
 strcpy(fsp_dir,"FSP_DIR=");
 strcat(fsp_dir, rdirname);
 (void) putenv(fsp_dir);
}

char homedir()
{
struct passwd *pass;
uid_t uid;

 uid = getuid();
 pass = getpwuid(uid);
 strcpy(home, pass->pw_dir);
}

readhosts()
{
FILE *lfile;
char line[80];
int c = 0, end = 0;

 strcpy(tempfile, hostf);
 lfile = fopen(tempfile, "r");
 tophost = 0;
 numhosts = 0;
 if (lfile) {
  while ((fscanf(lfile, "%s", line) != EOF) && (numhosts < 51)) {
   c++;
   if (line[strlen(line)-1] == 42) {
     line[strlen(line)-1] = 0;
     end = 1;
   }
   if (c == 1) strcpy(Lhosts[numhosts],line);
   if (c == 2) {
    strcpy(Lports[numhosts],line);
    strcpy(Lcomments[numhosts],"");
    }
   if (c > 2) {
    if ((strlen(Lcomments[numhosts])+strlen(line)) < 29) {
    strcat(Lcomments[numhosts],line);
    strcat(Lcomments[numhosts]," ");
    }
   }
   if (end) {
    c = 0;
    numhosts++;
    end = 0;
   }
  }
 }
}

selhost(by)
int by;
{
 int i;

 i = (((by - 20) / 15) + tophost);
 strcpy(hostname,Lhosts[i]);
 strcpy(portname,Lports[i]);
 strcpy(rfilname,"");
 strcpy(lfilname,"");
 strcpy(rdirname,"/");
 entries = 0;
 showstrings();
}


